/**

*/

#include "scream_rx.h"
#include "jbuf.h"
#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>
#include <string.h>
#include <stdio.h>

//#define LOCAL_DEBUG
#ifdef LOCAL_DEBUG
#	define TRACE(args) (printf("SCR: "), printf args)
#else
#	define TRACE(args)
#endif

enum { SCREAM_PKT_SIZE = 1157 };

/** Defines the Scream frame header */
struct scream_header {
    uint8_t rate;
    uint8_t width;
    uint8_t channels;
    uint8_t channelsMapLsb;
    uint8_t channelsMapMsb;
};

short samples[(SCREAM_PKT_SIZE - sizeof(struct scream_header))/2];


void on_scream_server_recv(struct sockaddr_in *addr, char *pusrdata, unsigned short len) {
    /** \todo check source IP:port to block simultaneous transmissions */
//	unsigned long rcid = *(unsigned long*)pusrdata;
//	if( rcid == taskid ) got = 1;
//	struct espconn *pespconn = (struct espconn *)arg;
#if 0
    ets_uart_printf("RECV %p, %p, %dB\n", arg, pusrdata, (int)len);
    char buf[16];
    strncpy(buf, pusrdata, sizeof(buf));
    buf[sizeof(buf)-1] = '\0';
    ets_uart_printf("DATA: %s\n", buf);
#endif

    if (len != SCREAM_PKT_SIZE) {
        return;
    }
#if 0
    printf(".");
    fflush(stdout);
#endif
    jbuf_eop();
    memcpy(samples, pusrdata + sizeof(struct scream_header), sizeof(samples));
    for (int i=0; i<(SCREAM_PKT_SIZE - sizeof(struct scream_header)) / 2; i++) {
        if (jbuf_put(samples[i])) {
            TRACE(("Overflow\n"));
            break;
        }
    }
}

void scream_rx_init(void) {
    //udp_init();
}
